<?php
/**************************************************************************
 * $Id: StudIPortExtAccPortalPlugin.class.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


/* always load config */
require_once('config/StudIPort.config.php');
require_once('lib/StudIPortDB.class.php');
require_once('vendor/flexi/flexi.php');


class StudIPortExtAccPortalPlugin extends AbstractStudIPPortalPlugin {

	public function __construct() {
		parent::AbstractStudIPPortalPlugin();
	}



	/*
	 * inserts additionally required CSS and JavaScript
	 * @param void
	 */
	public function initialize() {
		global $HELP_KEYWORD, $EXTERNAL_HELP_LOCATIONID;
		$HELP_KEYWORD="Basis.ePortfolio";
		$EXTERNAL_HELP_LOCATIONID = tuhh;

		// FIXME localization and foreign language support ....
		setlocale(LC_ALL, 'de_DE');
		new StudIPortDB("SET lc_time_names = 'de_DE'");

		// set additional headers
		global $_include_additional_header;
		$url = $this->getPluginURL();

		// get global uri constants
		global $STUDIPORT_URI;
		global $STUDIPORT_IMG_URI;
		global $STUDIPORT_CSS_URI;
		global $STUDIPORT_JS_URI;

		// include css
		$_include_additional_header .=
			"<link rel='stylesheet' href='". $STUDIPORT_CSS_URI ."/StudIPort.css' type='text/css' />\n" .
			"<link rel='stylesheet' href='". $STUDIPORT_CSS_URI ."/Calendar.css' type='text/css' />\n" .
			"<link rel='stylesheet' href='". $STUDIPORT_CSS_URI ."/fakeUploadButton.css' type='text/css' />\n";

		// include js
		$_include_additional_header .=
			"<script type='text/javascript'>var StudIPortImgUri = '". $STUDIPORT_IMG_URI ."/';</script>\n" .
			"<script type='text/javascript'>var StudIPortUrl = '". $STUDIPORT_URI ."/';</script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/CalendarPopup.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/StudIPortDefault.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/matrix.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/cache.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/msgBox.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/upload.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/file.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/ajax.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/view.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/question.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/response.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/fakeUploadButton.js'></script>\n" .
			"<script type='text/javascript' src='". $STUDIPORT_JS_URI ."/box.js'></script>\n";
	}	
	public function showOverview($authorizedview = false) {
		$factory = new Flexi_TemplateFactory(dirname(__FILE__) ."/templates");
		$template = $factory->open("ExtAccLogin.php");
		
		$url = $this->getPluginURL();
		$template->set_attribute("url", $url);
		$template->set_attribute("formaction", PluginEngine::getLink($this, NULL, "view"));
		
		echo $template->render();
  	}
	
	public function getPluginname() {
		return _("Externer Zugriff auf ePortfolios");
	}

	public function hasUnauthorizedView() {
		return false;
	}

	public function hasAuthorizedView() {
		return false;
	}
	
	public function hasAdministration() {
		return false;
	}
	
	public function actionview($pluginparams) {
		if (empty($_REQUEST["access_code"]) || empty($_REQUEST["view_id"])) {
			StudIPTemplateEngine::showErrorMessage("Geben Sie die geforderten Zugangsdaten an.");
			$this->showOverview();
			return;
		}
		
		$sql =& new DB_Seminar();
	
		$access_esc = mysql_real_escape_string($_REQUEST["access_code"]);
		$id_esc = mysql_real_escape_string(intval($_REQUEST["view_id"]));
	
		// check if code & id match
		$sql->queryf("SELECT view_id FROM studiport_view WHERE view_id = %u AND access_code = '%s' AND public = 'Y' AND (expires >= CURRENT_DATE OR ISNULL(expires))", $id_esc, $access_esc);
		if ($sql->num_rows() != 1) {
			StudIPTemplateEngine :: showErrorMessage("Ung&uuml;ltige Zugangsdaten");
			$this->showOverview();
			return;
		}
		
		// set the session variable for the external plugin and assign access code
		$_SESSION['StudIPortExtAcc']['access_code'] = $access_esc;
		
		$incPath_ = dirname(__FILE__) ."/lib/";
		$factory = new Flexi_TemplateFactory(dirname(__FILE__) ."/templates");
		$template = $factory->open("empty.php");
		$template->set_layout("StudIPortLayout.php");
		$template->set_attribute("url",  $this->getPluginURL());
		
		//require_once($incPath_ ."StudIPortFileListExtAcc.class.php");
		//$files = new StudIPortFileListExtAcc(new StudIPUser("nobody"), $id_esc);
		//$files->loadData();
		
		require_once($incPath_ ."StudIPortPageViewExtAcc.class.php");
		$files = new StudIPortPageViewExtAcc(new StudIPUser("nobody"), $id_esc);
		$files->loadData();
		
		$template->set_attribute('StudIPortContent', $files->render($factory, "StudIPortViewAlien.page.php", $this->getPluginURL()));
		echo $template->render();
	}
}
?>
