<?php
/**************************************************************************
 * $Id: StudIPortTextUpload.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once('config/StudIPort.config.php');
require_once('lib/StudIPortUploadTools.lib.php');
require_once('lib/StudIPortFileTools.lib.php');
require_once('lib/StudIPortTools.lib.php');
require_once('lib/StudIPortDB.class.php');
require_once('lib/PluginLink.lib.php');

// user auth
page_open(array(
	'sess' => 'Seminar_Session',
	'auth' => 'Seminar_Default_Auth',
	'perm' => 'Seminar_Perm',
	'user' => 'Seminar_User'));
$perm->check('autor');


if (!isset($_POST)) exit;

$text  = $_POST['TextUpload_File'];
$title = $_POST['TextUpload_Title'];

if (!isset($text)) {
	uploadError('Es wurde kein Text &uuml;bertragen!');
}

if (!isset($title)) {
	uploadError('Es wurde kein Text &uuml;bertragen!');
}

// a little less than 245 in case a file copy counter needs to be added like 'Neuer Text(4)'
if (strlen($title) > 245) {
	uploadError('Der Title darf nicht l&auml;nger als 245 Zeichen lang sein!');
}

if (empty($title)) {
	$title = 'Neuer Text';
}

// get db connection
$db =& new StudIPortDB();

// user id
$userid = $GLOBALS['user']->id;

// check quota
if (uploadGetCurUsage($userid) + $file['size'] > $STUDIPORT_FILES_QUOTA) {
	uploadError("Zu wenig Speicherplatz vorhanden");
}

// create unique filename
do {
	$intFileName = md5(uniqid('', true)); 
	$intFilePath = $STUDIPORT_DOWNLOAD_DIR ."/". $intFileName;
} while (file_exists($intFilePath));

// create file and insert text
if (! file_put_contents($intFilePath, $text)) {
	uploadError("Fehler beim Anlegen der Datei");
}

// FIXME use same function as in StudIPortFileUpload.php
$baseTitle = $title;
if (empty($title)) {
	$baseTitle = $title = $text;
}
for ($n = 2; $n <= $STUDIPORT_FILES_MAXDUP; $n++) {
	// IMPROVE and CHECK title vs filename
	$db->queryf("SELECT file_id FROM studiport_file WHERE title='%s' AND user_id='%s'", $title, $userid);
	if ($db->num_rows() == 0) {
		break;
	}
	$title = $baseTitle . " (" . $n . ")";
}
$filename = $title . STUDIPORT_FILES_DFLT_TEXT_EXT;

// insert everthing into DB
$db->queryf("INSERT INTO studiport_file SET "
	  . "int_filename  = '%s', "
	  . "filename      = '%s', "
	  . "type_id       = '%d', "
	  . "mimetype      = 'text/plain', "
	  . "filesize      = '%d', "
	  . "created       = NOW(), "
	  . "edited        = NOW(), "
	  . "title         = '%s', "
	  . "descr_int     = '', "
	  . "descr_ext     = '', "
	  . "user_id       = '%s'",
	  $intFileName, $filename, STUDIPORT_FILETYPE_TEXT, strlen($text), $title, $userid);

// check, if data could be inserted in mysql
if ($db->affected_rows() == 0) {
	uploadError('Text konnte nicht in Datenbank eingef&uuml;gt werden');
}

// get new list of unassociated files
// FIXME obsolete here
$fileObj = filesGetNoAssocList();
$fileList = array(
	'num' => $fileObj['number'],
	'htmlContent' => utf8_encode($fileObj['htmlContent'])
);
$fileListJSON = json_encode($fileList);

// get new quota statistics
$quota = uploadGetUsageStat($userid);
foreach ($quota as $k=>$v) {
	$quota[$k] = utf8_encode($v);
}
$quotaJSON = json_encode($quota);

// set success message and create a new upload key
$msg  = "Die Datei '". $title ."' wurde erfolgreich hochgeladen und kann nun zugeordnet werden.";
// FIXME obsolete here
$pkey = createUploadKey();

// show success or error message
// NOTE reloading Prototype is required by Konqueror (and possibly Safari) to
// make things like update() work
echo "<html><head>\n";
echo "<script type='text/javascript' src='". Assets::url('javascripts/prototype.js') ."'></script>\n";
echo "<script type='text/javascript'>\n";
echo "var pkey    = '". $pkey ."'\n";
echo "var msg     = '". addslashes(htmlentities($msg)) ."'\n";
echo "var fileLst = ". $fileListJSON ."\n";
echo "var quota   = ". $quotaJSON ."\n";
echo "top.textUpload.success(pkey, msg, quota, fileLst);\n";
echo "</script>\n";
echo "</head><body></body></html>\n";

// end of script, functions below
function uploadError($msg) {
	$pkey = createUploadKey();
	// NOTE reloading Prototype is required by Konqueror (and possibly Safari) to
	// make things like update() work
	echo "<html><head>\n";
	echo "<script type='text/javascript' src='". Assets::url('javascripts/prototype.js') ."'></script>\n";
	echo "<script type='text/javascript'>\ntop.textUpload.error('$pkey', '". addslashes(htmlentities($msg)) ."');\n</script>\n";
	echo "</head><body></body></html>\n";
	exit;
}

?>
