<?
/**************************************************************************
 * $Id: PluginLink.lib.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once(dirname(__FILE__) . "/../config/StudIPort.config.php");

/** generates a plugin link
 * @param subpage to display via plugin_subnavi_params
 * @param page to display (like myportfolio for example)
 * @param params array containing parameters to add
 */
function getPluginLink($subpage, $params = array(), $page = "") {
	$url = $GLOBALS['ABSOLUTE_URI_STUDIP'] . "plugins.php/". strtolower($GLOBALS['STUDIPORT_PLUGIN_CLASS']) ."/". $page;

	// add subpage
	if (!empty($subpage)) {
			$params = array_merge($params, array("plugin_subnavi_params" => $subpage));
	}

	// add requested user to link if we are on homepageplugin
	if (strtolower($GLOBALS['STUDIPORT_PLUGIN_CLASS']) == "studiporthomepageplugin") {
			$user = new StudIPUser();  // uses the globally available user ID
			$params = array_merge($params, array());
	}

	return URLHelper::getLink($url, $params);
}

?>
