<?php
/**************************************************************************
 * $Id: StudIPortDB.class.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


/** @class StudIPortDB
 * @brief class for db connection
 */
class StudIPortDB extends DB_Seminar
{
	/** walk result set
	 * overrides build-in studip next_record() function
	 *
	 * original copyright as stated in file 'lib/phplib/db_mysql_studip_inc':
	 * Copyright (C) 2006 Marco Diedrich <marco.diedrich@uni-osnabrueck.de>
	 *
	 * changes: - added parameter type which is passed to mysql_fetch_array()
	 * 			- use $this->query_id() instead of direct access to $this->Link_ID (private)
	 *			(Leo Krger <leo.krueger@tu-harburg.de>)
	 *
	 * @param type of arry to fetch (MYSQL_ASSOC, MYSQL_NUM or MYSQL_BOTH)
	 */
	public function next_record($type = MYSQL_ASSOC) {
		if (!$this->query_id()) {
			$this->halt("next_record called with no query pending.");
			return 0;
		}

		$this->Record = @mysql_fetch_array($this->query_id(), $type);
		$this->Row   += 1;
		$this->Errno  = mysql_errno();
		$this->Error  = mysql_error();

		$stat = is_array($this->Record);
		if (!$stat && $this->Auto_Free) {
			$this->free();
		}
		return $stat;
	}

	/** perform a query using format string
	 * overrides build-in studip queryf() function
	 *
	 * original copyright as stated in file 'lib/phplib/db_mysql_studip_inc':
	 * Copyright (C) 2006 Marco Diedrich <marco.diedrich@uni-osnabrueck.de>
	 *
	 * changes: - escape every element of $args with mysql_real_escape_string()
	 * 			(Leo Krger <leo.krueger@tu-harburg.de>)
	 *
	 * @param format the sql statement containing conversion specifications
	 * @param [more] which will be inserted in 'format'
	 */
	public function queryf($format /* , .. */) {

		// get args
		$args = func_get_args();

		// get format string
		$format = array_shift($args);

		// escape arguments
		foreach ($args as $key => &$value) {
			$args[$key] = mysql_real_escape_string($value);
		}
		
		// do something
		return $this->query(vsprintf($format, $args));
	}
}
?>
