<?php
/**************************************************************************
 * $Id: StudIPortPageFileListOwner.class.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once('StudIPortPage.class.php');
require_once('StudIPortFileListOwner.class.php');


class StudIPortPageFileListOwner extends StudIPortPage
{
	protected $fileList;

	public function loadData() {
		$this->fileList = new StudIPortFileListOwner($this->user);
                $this->fileList->loadData();
	}
	
	public function render(Flexi_TemplateFactory &$factory, $templateFilename, $pluginUrl) {
		parent::render($factory, $templateFilename, $pluginUrl);
		
		$this->template->set_attribute('fileList', $this->fileList->render($factory, "StudIPortFileList.part.php", $pluginUrl));

		return $this->template->render();
	}
	
	public function renderInfobox($pluginURL)
	{
		// this shit should be done differently, i.e., but not using the completely weird and messed up
		// StudIP infrastructure
		global $STUDIPORT_RELATIVE_PATH, $STUDIPORT_IMG_FOLDER;
		$icpa = '../../plugins_packages/'. $STUDIPORT_RELATIVE_PATH .'/'. $STUDIPORT_IMG_FOLDER;

		$info = array();
		$info[] = array ("icon" => "info.gif", "text" => _(
			"Auf dieser Seite sehen Sie die in Ihr ePortfolio hochgeladenen Dateien, "
			. "geordnet nach den verschiedenen Erfahrungsbereichen (Reiter) und Kompetenzen (Zeilen)."));

		$symb = array();
		$symb[] = array ("icon" => "$icpa/public-yes.png", "text" => _("Die Datei ist &ouml;ffentlich freigegeben."));
		$symb[] = array ("icon" => "$icpa/views-yes.png", "text" => _("Die Datei wurde Ansichten zugeordnet."));
		$symb[] = array ("icon" => "$icpa/edit.png", "text" => _("Aufruf des Dialogs <i>Dateieigenschaften</i>."));
		$symb[] = array ("icon" => "$icpa/trash.png", "text" => _("Die Datei in Ihrem ePortfolio l&ouml;schen."));
		$symb[] = array ("icon" => "$icpa/download.png", "text" => _("Datei herunterladen. Mehrere ausgew&auml;hlte Dateien werden gezippt."));
		$symb[] = array ("icon" => "$icpa/info-yes.png", "text" => _("Es gibt eine Datei-Beschreibung. Fahren Sie mit dem Mauszeiger &uuml;ber das Symbol, um sie anzuzeigen."));

		$infobox = array (
			array("kategorie" => _("Informationen:"), "eintrag" => $info),
			array("kategorie" => _("Symbole:"), "eintrag" => $symb));
		return parent::_renderInfobox($infobox, "infobox_lego.jpg");
	}
}
