<?php
/**************************************************************************
 * $Id: StudIPortPageMatrix.class.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once('StudIPortPage.class.php');
require_once('StudIPortMatrix.class.php');

/** @class StudIPortMatrix
 * @brief class to handle and create an eportfolio-matrix
 */
class StudIPortPageMatrix extends StudIPortPage
{
        protected $matrix;

        public function loadData() {
                $this->matrix = new StudIPortMatrix($this->user);
                $this->matrix->loadData();
        }

        public function render(Flexi_TemplateFactory &$factory, $templateFilename, $pluginUrl) {
                parent::render($factory, $templateFilename, $pluginUrl);

		// TODO ???
                //$this->template->set_attribute('matrix', $this->matrix->render($factory, "StudIPortMatrix.part.php", $pluginUrl));
                return $this->matrix->render($factory, "StudIPortMatrix.page.php", $pluginUrl);

                //return $this->template->render();
        }

	/** collects some data from database and builds array for infobox
	 * @see StudIPortPage::renderInfobox()
	 * @param void
	 */
	public function renderInfobox($pluginURL) {
		global $STUDIPORT_IMG_URI;
		$info1 =  array ("icon" => "info.gif", "text" => _("Dies ist Ihre Kompetenzmatrix. Fahren Sie mit dem Mauszeiger ber die Dateibilder in der Matrix, um sich die dort enthaltenen Dateien auflisten zu lassen."));

        $info2 =  array ("icon" => "vote-icon-visible.gif", "text" => _("Damit andere Benutzer Ihre Matrix anschauen knnen, mssen Sie diese <a href='". PluginEngine::getLink($GLOBALS['plugin'],array("plugin_subnavi_params"=>"views"), NULL) ."'>freigeben</a>."));

		$sql =& new DB_Seminar("SELECT * FROM studiport_matrix_exp_hide LEFT JOIN studiport_matrix_exp USING (exp_id)
								WHERE user_id = '". $this->user->getUserId() ."'");

		$content = "<ul>";

		if($sql->affected_rows() > 0) {
			while($sql->next_Record()) {
				$content .= "<li><a href=\"javascript:StudIPort.matrix.showHidePart(". $sql->Record["exp_id"] .", false, false)\"><img src=\"$STUDIPORT_IMG_URI/item-add.png\" width=\"16\" height=\"16\" alt=\"Wieder einblenden\" style=\"margin-right:5px\" /></a>". $sql->Record["title"] ."</li>";
			}
		} else { $content .= "- keine -"; }

		$content .= "</ul>";

		$info3 =  array ("icon" => "x_transparent.gif", "text" => _("Derzeit ausgeblendete Spalten: ". $content .""));

		$sql =& new DB_Seminar("SELECT * FROM studiport_matrix_comp_hide LEFT JOIN studiport_matrix_comp USING (comp_id)
								WHERE user_id = '". $this->user->getUserId() ."'");

		$content = "<div id='colhidelist'><ul>";

		if($sql->affected_rows() > 0) {
			while($sql->next_Record()) {
				$content .= "<li><a href=\"javascript:StudIPort.matrix.showHidePart(". $sql->Record["comp_id"] .", true, false)\"><img src=\"$STUDIPORT_IMG_URI/item-add.png\" width=\"16\" height=\"16\" alt=\"Wieder einblenden\" style=\"margin-right:5px\" /></a>". $sql->Record["title"] ."</li>";
			}
		} else { $content .= "- keine -"; }
		$content .= "</ul></div>";

		$info4 =  array ("icon" => "x_transparent.gif", "text" => _("Derzeit ausgeblendete Zeilen: ". $content .""));
		$infobox = array (array ("kategorie" => _("Informationen:"), "eintrag"   => array ($info1,$info2,$info3,$info4)));

		return parent::_renderInfobox($infobox, "infobox_lego.jpg");
	}
}
?>
