<?php
/**************************************************************************
 * $Id: StudIPortViewTools.lib.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


/**
 * get access list of provided view
 * @param
 * @return access list as associative array
 */
function getStudIPortViewAccessList ($view_id) {
	$lst = array();

	// make it an int
	$view_id = intval($view_id);

	// double-check it's not empty
	if (! empty($view_id)) {
		// establish DB connection
		$sql =& new DB_Seminar();

		// sanitize view id
		$view_id_esc = mysql_real_escape_string($view_id);

		// obtain data for given view
                global $_fullname_sql;
                $sql->query("SELECT user_id, username, ". $_fullname_sql['no_title_rev'] ." AS fullname, visible FROM studiport_view_access LEFT JOIN auth_user_md5 USING(user_id) WHERE view_id='$view_id_esc' ORDER BY fullname");

                while ($sql->next_record()) {
                        // FIXME: what if user is invisible? delete from view?
                        // NOTE: interface of get_visibility_by_state has changed in Stud.IP 1.8,
                        // due to introduction of domains -> resolve!
                        /*if (! get_visibility_by_state($sql->Record['visible'])) {
                                $sql->Record['fullname'] = "???";
                        }*/
                        array_push($lst, $sql->Record);
                }
	}

	return $lst;
}


function viewGetBasics($view_id) {
	$db =& new DB_Seminar();
	$view_id_esc = mysql_real_escape_string($view_id);
	$db->query("SELECT view_id, name, descr, IF(expires, DATE_FORMAT(expires, '%d.%m.%Y'), '---') as expires, IF(expires,expires<CURDATE(),FALSE) as expired, DATE_FORMAT(created, '%d.%m.%Y %k:%i Uhr') as created, DATE_FORMAT(edited, '%d.%m.%Y %k:%i Uhr') as edited, public, access_code FROM studiport_view WHERE view_id='$view_id_esc'");
	if ($db->num_rows() == 0) {
		return null;
	}
	$db->next_record();
	return $db->Record;
}


function viewCreateNewAccessCode() {
	return md5(rand() . microtime());
}


function viewGetExtAccessLink() {
	global $STUDIPORT_EXT_ACCESS_URI;
	return $STUDIPORT_EXT_ACCESS_URI;
}
?>
