<?php
/**************************************************************************
 * $Id: logging.php 4278 2010-08-26 08:55:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


global $_log_type;
global $_log_lvl;
global $_log_path;

// log types
$_log_type = array("trace" => 1, "warn"  => 2, "error" => 4);

// define constants for better handling
define (_TRACE, "trace");
define (_WARN, "warn");
define (_ERR, "error");

// set the log level
//$_log_lvl = 0x01 | 0x02 | 0x04;
$_log_lvl = 0;
// $_log_lvl = 4; // just log errors

// path to log dir
$_log_path = $GLOBALS['STUDIP_BASE_PATH'] ."/data/log/";

/**
 * @param stream
 * @param uid
 * @param str
 * @param param
 */
function debuglog($type, $uid, $str, $param = array())
{
	global $_log_type;
	global $_log_lvl;
	global $_log_path;
	
	// don't log event if type is not set in $loglvl
	if ($_log_type[$type] & $_log_lvl == 0) {
		return;
	}
	
	// check if log-path exists and is writeable
	if (!is_writable($_log_path)) {
		echo "Fehler: Logging nicht moeglich. #DIR404403";
		die();
	}

	// id to identify logged errors from one instance
	global $_log_id;
	
	// generate instance id if it's not defined yet
	if (!isset($_log_id)) {
		$_log_id = md5(uniqid(rand()));
	}

	$filename = $_log_path ."". $type ."". date("d.m.y") .".log";

	// open the file
	$handle = fopen($filename, "a");
	if (!$handle) {
		echo "Fehler: Logging nicht moeglich. #FILE404403";
		die();
	}
	
	$microsec = strtok(microtime(), " ");
	$sec = strtok(" ");
	
	$paramAsString = assocImplode($param);
	
	// build array with output
	// format is:
	// session id, instance id, time, user, description (string), {some parameters to identify problem}
	$output = array(session_id(), $_log_id, $sec, $microsec, $uid, $str, $paramAsString);

	// write output to file (csv style)
	fputcsv($handle, $output);
	
	// close file
	fclose($handle);
}

function assocImplode($input, $seperator = ",")
{
	$string = "";
	
	foreach ($input as $key => &$value) {
		if (strlen($string) != 0) {
			$string .= $seperator;
		}
		
		$string .= $key ."=>". $value;
	}

	return $string;
}

?>
